/*
 * Support and FAQ: visit <a href="https://www.microchip.com/support/">Microchip Support</a>
 */

#include <atmel_start.h>

/**
 * \brief Hardfault Handler
 *
 * Used in this example to identify when a location outside the reserved area
 * for SmartEEPROM is accessed.
 */
void HardFault_Handler(void)
{
	printf("\r\n!!!!!!!! In HardFault_Handler !!!!!!!!\r\n");

	while (1);
}




int main(void)
{
	/* If the custom loader already turn off OSCCTRL at MCLK register to avoid  */
	/* DPLL confliction, main application using XOSCn has to turn on OSCCTRL.   */
	/* Default value (power on reset) of OSCCTRL at MCLK register is 1.         */

	if(hri_mclk_get_APBAMASK_OSCCTRL_bit(MCLK) == 0)
		hri_mclk_set_APBAMASK_OSCCTRL_bit(MCLK);

	/* Initializes MCU, drivers, etc */
	atmel_start_init();

	printf("\r\n[SAME54 Xplained Pro]\r\n");
	printf("==== Main Application using XOSC1 ====\r\n");

	while(1)
	{
		gpio_toggle_pin_level(LED0);
		delay_ms(500);

		//printf("[MainApp] Toggle LED %d\r", gpio_get_pin_level(LED0));
	}
}
